#!/usr/bin/env python

""" Example for analyse URIs over a given domain to monitor """

__author__ = "Luis Campo Giralte"
__copyright__ = "Copyright (C) 2013-2015 by Luis Campo Giralte"
__revision__ = "$Id$"
__version__ = "0.1"
import sys
import os
import base64
import glob
sys.path.append("../src/")
import pyaiengine

def callback_uri(flow):

    ip = str(flow).split(":")[0]

    h = flow.getHTTPInfo()
    if (h):
        uri = str(h.getUri())
        if (uri):
            if ((uri.startswith("http") == False)and(uri[0] != "/")):
                if (uri.find('%') >= 0):
                    # The URI is encoded, so decode for analysis
                    try:
                        urie = base64.b64decode(uri)
                        print "Original:",uri
                        print "Decoded:",urie
                    except:
                        pass 

if __name__ == '__main__':

    # Load an instance of a Network Stack on Lan network
    st = pyaiengine.StackMobile()

    # Create a instace of a PacketDispatcher
    pdis = pyaiengine.PacketDispatcher()

    # Plug the stack on the PacketDispatcher
    pdis.setStack(st)

    dm = pyaiengine.DomainNameManager()

    dom = pyaiengine.DomainName("Service to analyze",
        "facebook.com")
    dom.setCallback(callback_uri)
    dm.addDomainName(dom)
    
    st.setHTTPHostNameManager(dm)

    st.setTotalTCPFlows(327680)
    st.setTotalUDPFlows(163840)

    files = glob.glob("/home/luis/pcapfiles/*.pcap")
    for f in files:
        pdis.open(f)

        pdis.run()

    pdis.close()

    sys.exit(0)

